package com.bonus.system.service.impl;

import java.util.ArrayList;
import java.util.List;

import com.bonus.system.api.domain.SysNotice;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.bonus.system.mapper.SysNoticeMapper;
import com.bonus.system.service.ISysNoticeService;

/**
 * 公告 服务层实现
 *
 * @author bonus
 */
@Service
public class SysNoticeServiceImpl implements ISysNoticeService
{
    private static final String HTML_REGEX = "(?s)<[^>]*>(\\s*<[^>]*>)*";

    @Autowired
    private SysNoticeMapper noticeMapper;

    /**
     * 查询公告信息
     *
     * @param noticeId 公告ID
     * @return 公告信息
     */
    @Override
    public SysNotice selectNoticeById(Long noticeId)
    {
        SysNotice sysNotice = noticeMapper.selectNoticeById(noticeId);
        sysNotice.setNoticeContentNoHtml(sysNotice.getNoticeContent().replaceAll(HTML_REGEX, ""));
        return sysNotice;
    }

    /**
     * 查询公告列表
     *
     * @param notice 公告信息
     * @return 公告集合
     */
    @Override
    public List<SysNotice> selectNoticeList(SysNotice notice)
    {
        List<SysNotice> list=new ArrayList<>();
        try{
            list = noticeMapper.selectNoticeList(notice);
            list.forEach(o -> {
                String content = o.getNoticeContent();
                o.setNoticeContentNoHtml(content != null ? content.replaceAll(HTML_REGEX, "") : "");
            });
        }catch (Exception e){
            e.printStackTrace();
        }
        return list;
    }

    /**
     * 新增公告
     *
     * @param notice 公告信息
     * @return 结果
     */
    @Override
    public int insertNotice(SysNotice notice)
    {
        return noticeMapper.insertNotice(notice);
    }

    /**
     * 修改公告
     *
     * @param notice 公告信息
     * @return 结果
     */
    @Override
    public int updateNotice(SysNotice notice)
    {
        return noticeMapper.updateNotice(notice);
    }

    /**
     * 删除公告对象
     *
     * @param noticeId 公告ID
     * @return 结果
     */
    @Override
    public int deleteNoticeById(Long noticeId)
    {
        return noticeMapper.deleteNoticeById(noticeId);
    }

    /**
     * 批量删除公告信息
     *
     * @param noticeIds 需要删除的公告ID
     * @return 结果
     */
    @Override
    public int deleteNoticeByIds(Long[] noticeIds)
    {
        return noticeMapper.deleteNoticeByIds(noticeIds);
    }
}
